'
'Astabiles Duo-FipFlop mit frei einstellbarer Kippzeit
'
'pinb.0 = Eingang Flip-Flop1 (aktiv L)
'pinb.1 = Eingang Flip-Flop2 (aktiv L)
'portb.2 = Ausgang Flip-Flop1 (aktiv H)
'portb.3 = Ausgang Flip-Flop2 (aktiv H)
'
'Die Zeit des Ausgangsimpuls bezieht sich auf 9,6MHz Takt!
'
'-------------------------------------------------------------------------------

$regfile = "attiny13.dat"                                   'verwendeter Prozessor
$crystal = 9600000                                          'Definition des Takt

Stop Adc                                                    'Switch off the power to the AD Converter
Stop Ac                                                     'Switch off the power to the Analog Comparator
Reset Acsr. Acbg                                            'Disable Analog Comparator Bandgap Select

Ddrb = &B0000_1100                                          'konf Port's B auf > 0=Eingabe 1=Ausgabe
Pinb = &B0000_0011                                          'Pullup-Widerstand setzen
Dim A as Word                                               'Zhler Flip-Flop A
Dim B as Word                                               'Zhler Flip-Flop B

config debounce = 0                                         'Zeit fr Tastenentprellung auf 0 setzen

'Programm ======================================================================

     do

     if portb.2=0 then debounce pinb.0,0,FFA,sub       'Flip-Flop A
     if portb.3=0 then debounce pinb.1,0,FFB,sub       'Flip-Flop B

'Flip-Flop A

     if portb.2=1 then A=A+1
     if A=16000 then                                   'A=16000 ~100ms Ausgangsimpuls
     portb.2=0
     A=0
     endif

'Flip-Flop B

     if portB.3=1 then B=B+1
     if B=8000 then                                    'B=8000 ~50ms Ausgangsimpuls
     portb.3=0
     B = 0
     endif

     loop

'Unterroutine ==================================================================

FFA:

     PortB.2=1
     return

FFB:

     portb.3=1
     return